import Text.Printf

type GoID  = Int
type Level = Int

data GameObject = GameObject
    { goID   :: GoID
    , render :: IO ()
    , update :: GameObject }

banana :: GoID -> GameObject
banana goid =
    GameObject
    { goID   = goid
    , render = printf "banana: id %d\n" goid
    , update = banana goid }

apple :: Level -> GoID -> GameObject
apple level goid =
    GameObject
    { goID   = goid
    , render = printf "apple: id %d, level %d\n" goid level
    , update = apple (level+1) goid }